summaryrefslogtreecommitdiff
path: root/scripts/Kbuild.include (plain)
blob: f40431fd7df15a69c0bd683219308686dd82fdd3
1####
2# kbuild: Generic definitions
3
4# Convenient variables
5comma := ,
6quote := "
7squote := '
8empty :=
9space := $(empty) $(empty)
10space_escape := _-_SPACE_-_
11pound := \#
12
13###
14# Name of target with a '.' as filename prefix. foo/bar.o => foo/.bar.o
15dot-target = $(dir $@).$(notdir $@)
16
17###
18# The temporary file to save gcc -MD generated dependencies must not
19# contain a comma
20depfile = $(subst $(comma),_,$(dot-target).d)
21
22###
23# filename of target with directory and extension stripped
24basetarget = $(basename $(notdir $@))
25
26###
27# filename of first prerequisite with directory and extension stripped
28baseprereq = $(basename $(notdir $<))
29
30###
31# Escape single quote for use in echo statements
32escsq = $(subst $(squote),'\$(squote)',$1)
33
34###
35# Easy method for doing a status message
36 kecho := :
37 quiet_kecho := echo
38silent_kecho := :
39kecho := $($(quiet)kecho)
40
41###
42# filechk is used to check if the content of a generated file is updated.
43# Sample usage:
44# define filechk_sample
45# echo $KERNELRELEASE
46# endef
47# version.h : Makefile
48# $(call filechk,sample)
49# The rule defined shall write to stdout the content of the new file.
50# The existing file will be compared with the new one.
51# - If no file exist it is created
52# - If the content differ the new file is used
53# - If they are equal no change, and no timestamp update
54# - stdin is piped in from the first prerequisite ($<) so one has
55# to specify a valid file as first prerequisite (often the kbuild file)
56define filechk
57 $(Q)set -e; \
58 $(kecho) ' CHK $@'; \
59 mkdir -p $(dir $@); \
60 $(filechk_$(1)) < $< > $@.tmp; \
61 if [ -r $@ ] && cmp -s $@ $@.tmp; then \
62 rm -f $@.tmp; \
63 else \
64 $(kecho) ' UPD $@'; \
65 mv -f $@.tmp $@; \
66 fi
67endef
68
69######
70# gcc support functions
71# See documentation in Documentation/kbuild/makefiles.txt
72
73# cc-cross-prefix
74# Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
75# Return first prefix where a prefix$(CC) is found in PATH.
76# If no $(CC) found in PATH with listed prefixes return nothing
77cc-cross-prefix = \
78 $(word 1, $(foreach c,$(1), \
79 $(shell set -e; \
80 if (which $(strip $(c))$(CC)) > /dev/null 2>&1 ; then \
81 echo $(c); \
82 fi)))
83
84# output directory for tests below
85TMPOUT := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/)
86
87# try-run
88# Usage: option = $(call try-run, $(CC)...-o "$$TMP",option-ok,otherwise)
89# Exit code chooses option. "$$TMP" is can be used as temporary file and
90# is automatically cleaned up.
91try-run = $(shell set -e; \
92 TMP="$(TMPOUT).$$$$.tmp"; \
93 TMPO="$(TMPOUT).$$$$.o"; \
94 if ($(1)) >/dev/null 2>&1; \
95 then echo "$(2)"; \
96 else echo "$(3)"; \
97 fi; \
98 rm -f "$$TMP" "$$TMPO")
99
100# as-option
101# Usage: cflags-y += $(call as-option,-Wa$(comma)-isa=foo,)
102
103as-option = $(call try-run,\
104 $(CC) $(KBUILD_CFLAGS) $(1) -c -x assembler /dev/null -o "$$TMP",$(1),$(2))
105
106# as-instr
107# Usage: cflags-y += $(call as-instr,instr,option1,option2)
108
109as-instr = $(call try-run,\
110 printf "%b\n" "$(1)" | $(CC) $(KBUILD_AFLAGS) -c -x assembler -o "$$TMP" -,$(2),$(3))
111
112# __cc-option
113# Usage: MY_CFLAGS += $(call __cc-option,$(CC),$(MY_CFLAGS),-march=winchip-c6,-march=i586)
114__cc-option = $(call try-run,\
115 $(1) -Werror $(2) $(3) -c -x c /dev/null -o "$$TMP",$(3),$(4))
116
117# Do not attempt to build with gcc plugins during cc-option tests.
118# (And this uses delayed resolution so the flags will be up to date.)
119CC_OPTION_CFLAGS = $(filter-out $(GCC_PLUGINS_CFLAGS),$(KBUILD_CFLAGS))
120
121# cc-option
122# Usage: cflags-y += $(call cc-option,-march=winchip-c6,-march=i586)
123
124cc-option = $(call __cc-option, $(CC),\
125 $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS),$(1),$(2))
126
127# hostcc-option
128# Usage: cflags-y += $(call hostcc-option,-march=winchip-c6,-march=i586)
129hostcc-option = $(call __cc-option, $(HOSTCC),\
130 $(HOSTCFLAGS) $(HOST_EXTRACFLAGS),$(1),$(2))
131
132# cc-option-yn
133# Usage: flag := $(call cc-option-yn,-march=winchip-c6)
134cc-option-yn = $(call try-run,\
135 $(CC) -Werror $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",y,n)
136
137# cc-option-align
138# Prefix align with either -falign or -malign
139cc-option-align = $(subst -functions=0,,\
140 $(call cc-option,-falign-functions=0,-malign-functions=0))
141
142# cc-disable-warning
143# Usage: cflags-y += $(call cc-disable-warning,unused-but-set-variable)
144cc-disable-warning = $(call try-run,\
145 $(CC) -Werror $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) -W$(strip $(1)) -c -x c /dev/null -o "$$TMP",-Wno-$(strip $(1)))
146
147# cc-name
148# Expands to either gcc or clang
149cc-name = $(shell $(CC) -v 2>&1 | grep -q "clang version" && echo clang || echo gcc)
150
151# __cc-version
152# Returns compiler version
153__cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/$(cc-name)-version.sh $(CC))
154
155# __cc-fullversion
156# Returns full compiler version
157__cc-fullversion = $(shell $(CONFIG_SHELL) \
158 $(srctree)/scripts/$(cc-name)-version.sh -p $(CC))
159
160# __cc-ifversion
161# Matches compiler name and version
162# Usage: EXTRA_CFLAGS += $(call cc-if-name-version, gcc, -lt, 0402, -O1)
163__cc-ifversion = $(shell [ $(cc-name) = $(1) ] && [ $(__cc-version) $(2) $(3) ] && echo $(4) || echo $(5))
164
165# __cc-if-fullversion
166# Matches compiler name and full version
167# Usage: EXTRA_CFLAGS += $(call cc-if-name-fullversion, gcc, -lt, 040502, -O1)
168__cc-if-fullversion = $(shell [ $(cc-name) = $(1) ] && [ $(__cc-fullversion) $(2) $(3) ] && echo $(4) || echo $(5))
169
170# gcc-ifversion
171gcc-ifversion = $(call __cc-ifversion, gcc, $(1), $(2), $(3), $(4))
172
173# gcc-if-fullversion
174gcc-if-fullversion = (call __cc-if-fullversion, gcc, $(1), $(2), $(3), $(4))
175
176# clang-ifversion
177clang-ifversion = $(call __cc-ifversion, clang, $(1), $(2), $(3), $(4))
178
179# clang-if-fullversion
180clang-if-fullversion = (call __cc-if-fullversion, clang, $(1), $(2), $(3), $(4))
181
182# cc-version
183cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-version.sh $(CC))
184
185# cc-fullversion
186cc-fullversion = $(shell $(CONFIG_SHELL) \
187 $(srctree)/scripts/gcc-version.sh -p $(CC))
188
189# backward compatibility
190cc-ifversion = $(gcc-ifversion)
191cc-if-fullversion = $(gcc-if-fullversion)
192
193# cc-ldoption
194# Usage: ldflags += $(call cc-ldoption, -Wl$(comma)--hash-style=both)
195cc-ldoption = $(call try-run,\
196 $(CC) $(1) $(KBUILD_CPPFLAGS) $(CC_OPTION_CFLAGS) -nostdlib -x c /dev/null -o "$$TMP",$(1),$(2))
197
198# ld-option
199# Usage: LDFLAGS += $(call ld-option, -X)
200ld-option = $(call try-run, $(LD) $(LDFLAGS) $(1) -v,$(1),$(2))
201
202# ar-option
203# Usage: KBUILD_ARFLAGS := $(call ar-option,D)
204# Important: no spaces around options
205ar-option = $(call try-run, $(AR) rc$(1) "$$TMP",$(1),$(2))
206
207# ld-name
208# Expands to either bfd or gold
209ld-name = $(shell $(LD) -v 2>&1 | grep -q "GNU gold" && echo gold || echo bfd)
210
211# ld-version
212# Note this is mainly for HJ Lu's 3 number binutil versions
213ld-version = $(shell $(LD) --version | $(srctree)/scripts/ld-version.sh)
214
215# ld-ifversion
216# Usage: $(call ld-ifversion, -ge, 22252, y)
217ld-ifversion = $(shell [ $(ld-version) $(1) $(2) ] && echo $(3) || echo $(4))
218
219# __ld-ifversion
220# Usage: $(call __ld-ifversion, gold, -ge, 112000000, y)
221__ld-ifversion = $(shell [ $(ld-name) = $(1) ] && [ $(ld-version) $(2) $(3) ] && echo $(4) || echo $(5))
222
223# bfd-ifversion
224# Usage: $(call bfd-ifversion, -ge, 227000000, y)
225bfd-ifversion = $(call __ld-ifversion, bfd, $(1), $(2), $(3), $(4))
226
227# gold-ifversion
228# Usage: $(call gold-ifversion, -ge, 112000000, y)
229gold-ifversion = $(call __ld-ifversion, gold, $(1), $(2), $(3), $(4))
230
231######
232
233###
234# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.build obj=
235# Usage:
236# $(Q)$(MAKE) $(build)=dir
237build := -f $(srctree)/scripts/Makefile.build obj
238
239###
240# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.modbuiltin obj=
241# Usage:
242# $(Q)$(MAKE) $(modbuiltin)=dir
243modbuiltin := -f $(srctree)/scripts/Makefile.modbuiltin obj
244
245###
246# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.dtbinst obj=
247# Usage:
248# $(Q)$(MAKE) $(dtbinst)=dir
249dtbinst := -f $(if $(KBUILD_SRC),$(srctree)/)scripts/Makefile.dtbinst obj
250
251###
252# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.clean obj=
253# Usage:
254# $(Q)$(MAKE) $(clean)=dir
255clean := -f $(srctree)/scripts/Makefile.clean obj
256
257###
258# Shorthand for $(Q)$(MAKE) -f scripts/Makefile.headersinst obj=
259# Usage:
260# $(Q)$(MAKE) $(hdr-inst)=dir
261hdr-inst := -f $(srctree)/scripts/Makefile.headersinst obj
262
263# Prefix -I with $(srctree) if it is not an absolute path.
264# skip if -I has no parameter
265addtree = $(if $(patsubst -I%,%,$(1)), \
266$(if $(filter-out -I/% -I./% -I../%,$(1)),$(patsubst -I%,-I$(srctree)/%,$(1)),$(1)))
267
268# Find all -I options and call addtree
269flags = $(foreach o,$($(1)),$(if $(filter -I%,$(o)),$(call addtree,$(o)),$(o)))
270
271# echo command.
272# Short version is used, if $(quiet) equals `quiet_', otherwise full one.
273echo-cmd = $(if $($(quiet)cmd_$(1)),\
274 echo ' $(call escsq,$($(quiet)cmd_$(1)))$(echo-why)';)
275
276# printing commands
277cmd = @$(echo-cmd) $(cmd_$(1))
278
279# Add $(obj)/ for paths that are not absolute
280objectify = $(foreach o,$(1),$(if $(filter /%,$(o)),$(o),$(obj)/$(o)))
281
282###
283# if_changed - execute command if any prerequisite is newer than
284# target, or command line has changed
285# if_changed_dep - as if_changed, but uses fixdep to reveal dependencies
286# including used config symbols
287# if_changed_rule - as if_changed but execute rule instead
288# See Documentation/kbuild/makefiles.txt for more info
289
290ifneq ($(KBUILD_NOCMDDEP),1)
291# Check if both arguments are the same including their order. Result is empty
292# string if equal. User may override this check using make KBUILD_NOCMDDEP=1
293arg-check = $(filter-out $(subst $(space),$(space_escape),$(strip $(cmd_$@))), \
294 $(subst $(space),$(space_escape),$(strip $(cmd_$1))))
295else
296arg-check = $(if $(strip $(cmd_$@)),,1)
297endif
298
299# Replace >$< with >$$< to preserve $ when reloading the .cmd file
300# (needed for make)
301# Replace >#< with >$(pound)< to avoid starting a comment in the .cmd file
302# (needed for make)
303# Replace >'< with >'\''< to be able to enclose the whole string in '...'
304# (needed for the shell)
305make-cmd = $(call escsq,$(subst $(pound),$$(pound),$(subst $$,$$$$,$(cmd_$(1)))))
306
307# Find any prerequisites that is newer than target or that does not exist.
308# PHONY targets skipped in both cases.
309any-prereq = $(filter-out $(PHONY),$?) $(filter-out $(PHONY) $(wildcard $^),$^)
310
311# Execute command if command has changed or prerequisite(s) are updated.
312#
313if_changed = $(if $(strip $(any-prereq) $(arg-check)), \
314 @set -e; \
315 $(echo-cmd) $(cmd_$(1)); \
316 printf '%s\n' 'cmd_$@ := $(make-cmd)' > $(dot-target).cmd, @:)
317
318# Execute the command and also postprocess generated .d dependencies file.
319if_changed_dep = $(if $(strip $(any-prereq) $(arg-check) ), \
320 @set -e; \
321 $(cmd_and_fixdep), @:)
322
323ifndef CONFIG_TRIM_UNUSED_KSYMS
324
325cmd_and_fixdep = \
326 $(echo-cmd) $(cmd_$(1)); \
327 scripts/basic/fixdep $(depfile) $@ '$(make-cmd)' > $(dot-target).tmp;\
328 rm -f $(depfile); \
329 mv -f $(dot-target).tmp $(dot-target).cmd;
330
331else
332
333# Filter out exported kernel symbol names from the preprocessor output.
334# See also __KSYM_DEPS__ in include/linux/export.h.
335# We disable the depfile generation here, so as not to overwrite the existing
336# depfile while fixdep is parsing it.
337flags_nodeps = $(filter-out -Wp$(comma)-M%, $($(1)))
338ksym_dep_filter = \
339 case "$(1)" in \
340 cc_*_c|cpp_i_c) \
341 $(CPP) $(call flags_nodeps,c_flags) -D__KSYM_DEPS__ $< ;; \
342 as_*_S|cpp_s_S) \
343 $(CPP) $(call flags_nodeps,a_flags) -D__KSYM_DEPS__ $< ;; \
344 boot*|build*|*cpp_lds_S|dtc|host*|vdso*) : ;; \
345 *) echo "Don't know how to preprocess $(1)" >&2; false ;; \
346 esac | tr ";" "\n" | sed -rn 's/^.*=== __KSYM_(.*) ===.*$$/KSYM_\1/p'
347
348cmd_and_fixdep = \
349 $(echo-cmd) $(cmd_$(1)); \
350 $(ksym_dep_filter) | \
351 scripts/basic/fixdep -e $(depfile) $@ '$(make-cmd)' \
352 > $(dot-target).tmp; \
353 rm -f $(depfile); \
354 mv -f $(dot-target).tmp $(dot-target).cmd;
355
356endif
357
358# Usage: $(call if_changed_rule,foo)
359# Will check if $(cmd_foo) or any of the prerequisites changed,
360# and if so will execute $(rule_foo).
361if_changed_rule = $(if $(strip $(any-prereq) $(arg-check) ), \
362 @set -e; \
363 $(rule_$(1)), @:)
364
365###
366# why - tell why a a target got build
367# enabled by make V=2
368# Output (listed in the order they are checked):
369# (1) - due to target is PHONY
370# (2) - due to target missing
371# (3) - due to: file1.h file2.h
372# (4) - due to command line change
373# (5) - due to missing .cmd file
374# (6) - due to target not in $(targets)
375# (1) PHONY targets are always build
376# (2) No target, so we better build it
377# (3) Prerequisite is newer than target
378# (4) The command line stored in the file named dir/.target.cmd
379# differed from actual command line. This happens when compiler
380# options changes
381# (5) No dir/.target.cmd file (used to store command line)
382# (6) No dir/.target.cmd file and target not listed in $(targets)
383# This is a good hint that there is a bug in the kbuild file
384ifeq ($(KBUILD_VERBOSE),2)
385why = \
386 $(if $(filter $@, $(PHONY)),- due to target is PHONY, \
387 $(if $(wildcard $@), \
388 $(if $(strip $(any-prereq)),- due to: $(any-prereq), \
389 $(if $(arg-check), \
390 $(if $(cmd_$@),- due to command line change, \
391 $(if $(filter $@, $(targets)), \
392 - due to missing .cmd file, \
393 - due to $(notdir $@) not in $$(targets) \
394 ) \
395 ) \
396 ) \
397 ), \
398 - due to target missing \
399 ) \
400 )
401
402echo-why = $(call escsq, $(strip $(why)))
403endif
404
405###############################################################################
406#
407# When a Kconfig string contains a filename, it is suitable for
408# passing to shell commands. It is surrounded by double-quotes, and
409# any double-quotes or backslashes within it are escaped by
410# backslashes.
411#
412# This is no use for dependencies or $(wildcard). We need to strip the
413# surrounding quotes and the escaping from quotes and backslashes, and
414# we *do* need to escape any spaces in the string. So, for example:
415#
416# Usage: $(eval $(call config_filename,FOO))
417#
418# Defines FOO_FILENAME based on the contents of the CONFIG_FOO option,
419# transformed as described above to be suitable for use within the
420# makefile.
421#
422# Also, if the filename is a relative filename and exists in the source
423# tree but not the build tree, define FOO_SRCPREFIX as $(srctree)/ to
424# be prefixed to *both* command invocation and dependencies.
425#
426# Note: We also print the filenames in the quiet_cmd_foo text, and
427# perhaps ought to have a version specially escaped for that purpose.
428# But it's only cosmetic, and $(patsubst "%",%,$(CONFIG_FOO)) is good
429# enough. It'll strip the quotes in the common case where there's no
430# space and it's a simple filename, and it'll retain the quotes when
431# there's a space. There are some esoteric cases in which it'll print
432# the wrong thing, but we don't really care. The actual dependencies
433# and commands *do* get it right, with various combinations of single
434# and double quotes, backslashes and spaces in the filenames.
435#
436###############################################################################
437#
438define config_filename
439ifneq ($$(CONFIG_$(1)),"")
440$(1)_FILENAME := $$(subst \\,\,$$(subst \$$(quote),$$(quote),$$(subst $$(space_escape),\$$(space),$$(patsubst "%",%,$$(subst $$(space),$$(space_escape),$$(CONFIG_$(1)))))))
441ifneq ($$(patsubst /%,%,$$(firstword $$($(1)_FILENAME))),$$(firstword $$($(1)_FILENAME)))
442else
443ifeq ($$(wildcard $$($(1)_FILENAME)),)
444ifneq ($$(wildcard $$(srctree)/$$($(1)_FILENAME)),)
445$(1)_SRCPREFIX := $(srctree)/
446endif
447endif
448endif
449endif
450endef
451#
452###############################################################################
453
454# delete partially updated (i.e. corrupted) files on error
455.DELETE_ON_ERROR:
456